function Q5_reduction

close all
clear all

% INPUT THE INCLINATION in degrees HERE----------------------
I_deg=75;
%-----------------------------------------------
% AND THE DECLINATION in degrees HERE----------------------
D_deg=50;
%----------------------------------------

high_limit=2750; %plotting values for corrected data
low_limit=-4500;


I=(I_deg*pi)/180;
D=(D_deg*pi)/180;

diur=load('corr.txt');% column 1 - east
                     % column 2 - north
                     % column 3 - diurnally corrected mag
                     % column 4 - time
                     


i=sqrt(-1);

nx=256;
ny=nx;

linx(1,:)=linspace(min(diur(:,1)),max(diur(:,1)),nx);
liny(:,1)=linspace(min(diur(:,2)),max(diur(:,2)),ny);

IBA=griddata(diur(:,1),diur(:,2),diur(:,3),linx,liny,'v4');

% Remove the regional trend:

X(:,1)=ones(length(linx),1);
X(:,2)=linx;
X(:,3)=liny;

a=inv((X')*X)*X'*IBA;

for j=1:length(linx)
    for k =1:length(liny)
     trend(j,k)=a(1,1)+(a(2,1)*linx(1,j))+(a(3,1)*liny(k,1));
    end
end
pcolor(linx,liny,IBA)
caxis([low_limit high_limit]);
shading flat
shading interp
title('Pre Linear Trend Removal (nT)')
xlabel('Eastings (m)')
ylabel('Northings (m)')
colorbar


IBA=IBA-trend;

figure
pcolor(linx,liny,IBA)
caxis([low_limit high_limit]);
shading flat
shading interp
title('Post Linear Trend Removal (nT)')
xlabel('Eastings (m)')
ylabel('Northings (m)')
colorbar

dx=mean(diff(linx));
dy=mean(diff(liny));

nyqx=(1/(2*dx));
nyqy=(1/(2*dy));

kx=linspace(-nyqx,nyqx,nx);
ky=linspace(-nyqy,nyqy,ny);

L=cos(I)*cos(D);
l=cos(I)*cos(D);
R=cos(I)*sin(D);
r=cos(I)*sin(D);
Q=sin(I);
q=sin(I);


[KX KY]=meshgrid(kx,ky);
Kx=KX.*KX;
Ky=KY.*KY;

for m= 1:nx
    for n= 1:ny
        RTP(m,n)=(Kx(m,n)+Ky(m,n))/(( (i*L*KX(m,n)) + (i*R*KY(m,n)) + (Q*((Kx(m,n)+Ky(m,n)).^0.5))) .* ( (i*l*KX(m,n)) + (i*r*KY(m,n)) + (q*((Kx(m,n)+Ky(m,n)).^0.5)) ));
    end
end

RTP=fftshift(RTP);

filtR_dat=real(ifft2(fft2(IBA).*RTP));

figure
pcolor(linx,liny,filtR_dat)
caxis([low_limit high_limit]);
colorbar;
%set(get(colorbar,'ylabel'),'string','Power')
shading interp;
shading flat;
title('Reduced to the Pole (nT)')
xlabel('Eastings (m)')
ylabel('Northings (m)')

save('Reduced.mat','linx','liny','filtR_dat','IBA')